import re
import emoji


class HtmlMsg:

    def get_msg(self, data=None) -> str:
        pass

    def get_stylized_msg(self, msg):
        msg = self.replace_tag_tag(msg, "p")
        msg = self.replace_tag_tag(msg, "h1")
        msg = self.replace_tag_tag(msg, "secure")

        return msg

    def replace_tag_p(self, msg: str):
        msg = msg.replace("<p>", "")
        msg = msg.replace("</p>", "")

        return msg

    def replace_tag_tag(self, msg: str, tag: str):
        msg = msg.replace("<{tag}>".format(tag=tag), "")
        msg = msg.replace("</{tag}>".format(tag=tag), "")

        return msg

    def replace_single_tag(self, msg: str, tag: str):
        msg = msg.replace("<{tag}>".format(tag=tag), "")

        return msg

    def replace_tag_with_content(self, msg: str, tag: str):
        msg = msg.replace("\r\n", "<br>")
        msg = re.sub("<{tag}>.*?</{tag}>".format(tag=tag), '', msg, 0)
        msg = msg.replace("<br>", "\r\n")

        return msg

    @staticmethod
    def remove_emoji(string):
        emoji_pattern = re.compile("["
                                   u"\U0001F600-\U0001F64F"  # emoticons
                                   u"\U0001F300-\U0001F5FF"  # symbols & pictographs
                                   u"\U0001F680-\U0001F6FF"  # transport & map symbols
                                   u"\U0001F1E0-\U0001F1FF"  # flags (iOS)
                                   u"\U00002702-\U000027B0"
                                   u"\U000024C2-\U0001F251"
                                   "]+", flags=re.UNICODE)
        return emoji_pattern.sub(r'', string)